package ml;

import ml.active.*;
import weka.core.*;
import weka.active.*;

import ml.util.config.*;

/**
 * <p>Title: Active Learning</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ActiveLearning {
    private XActiveLearner learner;

    public ActiveLearning() {
        System.out.println("running with KFF");
        learner = new KFF();
        /*try {
            learner = ActiveLearningAlgsFactory.create(learningAlg);
            learner.startActiveLearningSession();

                 } catch (Exception exp) {
            exp.printStackTrace();
            System.out.println("\n Terminating This Session.. \n");
            System.exit(1);
                 }*/
    }

    public void init(DataContainer data) {
        try {
            learner.buildClassifier(data);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public double[] classify(DataContainer data) throws Exception {
        double[] res = new double[data.size()];
        for (int i = 0, test = data.size(); i < test; ++i) {
            res[i] = learner.classifyInstance(data.getInstance(i));
        }
        return res;
    }

    public int indexToQuery(DataContainer pool) throws Exception {
        return learner.instanceToQuery(pool);
    }

    public DataContainer create(String dataFile) throws Exception {
        return learner.create(dataFile);
    }

    public DataContainer create(double[][] attributes, double[] labels) throws
            Exception {
        return learner.create(attributes, labels);
    }

    public static void main(String[] args) {
        /*try {
            ActiveLearning learner = new ActiveLearning();
            /*
              double [][] att= { {1,2,3}, {1,2,4}, {0,2,3}, {0,2,4} };
                         double[] lb= {1,1,-1,-1};

                         DataContainer data = learner.create(att,lb);
                         System.out.println("test");
              /* /


               DataContainer pool = learner.create("data/formattest.libsvm"); //"data/blocks10RGB.libsvm");
              System.out.println("Number of samples :" + pool.size());

              System.exit(0);
              DataContainer data = learner.create("data/data.libsvm");

              learner.init(data);

              for (int i = 0; i < 10; ++i) {
                  int ind = learner.indexToQuery(pool);
                  System.out.println("query index = " + ind);

                  InstanceContainer ins = pool.getInstance(ind);
                  pool.deleteInstance(ind);

                  ins.setClassValue(i % 2);
                  data.addInstance(ins);

                  learner.init(data);
              }

                   } catch (Exception e) {
              e.printStackTrace();
                   } */

          try {
              XmlReadOnlyConfig config = new XmlReadOnlyConfig();
              config.init("config/config.xml");

              String []run_args = {"-t", config.get("run/dataset"),
                                  "-o", config.get("run/resFile"),
                                  "-x", config.get("run/folds"),
                                  "-m",config.get("run/num_query")};

              LearnersFactory factory = new LearnersFactory();

              XActiveLearner learner = factory.create(config.get("run/alg"), config);

              System.out.println(XActiveEvaluationPlotter.evaluateModelAndPlot(
                      learner, run_args));
          } catch (Exception e) {
              System.err.println(e.getMessage());
              e.printStackTrace();
          }

    }
}
